/* Tecnisa - Tecnologia em Informtica

 Nome: Movimentao de Estoque

 Descrio:
 Procedimento para gerao e totalizao dos dados de movimentao de estoque

 Criao:
 06/04/98 - Roberto A. Lopes Martins

 @C:\Web_605\Sql\End_Conv\Oracle\3999_ESTSTPO_CALCULA_SALDO_ANTERIOR.SQL

  raise_application_error(-20501, '' , True);

*/

CREATE OR REPLACE PROCEDURE CALCULA_SALDO_ANTERIOR(
   P_CDFILIAL      IN  ITLANCTOEST.CDFILIAL%TYPE,
   P_NRLANCESTQ    IN  ITLANCTOEST.NRLANCESTQ%TYPE,
   P_CDFILIMOVI    IN  ITLANCTOEST.CDFILIMOVI%TYPE,
   P_CDPRODUTO     IN  ITLANCTOEST.CDPRODMOVI%TYPE,
   P_CDALMOXARIFE  IN  ITLANCTOEST.CDALMOXARIFE%TYPE,
   P_CDLOCALESTOQ  IN  ITLANCTOEST.CDLOCALESTOQ%TYPE,
   P_NRLOTEESTQ    IN  ITLANCTOEST.NRLOTEESTQ%TYPE,
   P_NRSUBLOTE     IN  ITLANCTOEST.NRSUBLOTE%TYPE,
   P_DTPOSIESTQ    IN  POSESTDIA.DTPOSIESTQ%TYPE,
   P_QTESTOQDIA    OUT POSESTDIA.QTESTOQDIA%TYPE,
   P_VRESTOQDIA    OUT POSESTDIA.VRESTOQDIA%TYPE,
   P_VRESTOQBRUT   OUT POSESTDIA.VRESTOQBRUT%TYPE,
   P_QTESTOQANT    OUT POSESTDIA.QTESTOQDIA%TYPE,
   P_VRESTANT      OUT POSESTDIA.VRESTOQDIA%TYPE,
   P_MOVI          IN VARCHAR DEFAULT 'S')

AS

   V_QTDEESTO      NUMBER;
   V_VALRESTO      NUMBER;
   V_VALRBRUT      NUMBER;
   V_QTDEANTE      NUMBER;
   V_VRESTANT      NUMBER;
   V_VRBRUANT      NUMBER;
   V_QTDEESTOPOS   NUMBER;
   V_VALRESTOPOS   NUMBER;
   V_VALRBRUTPOS   NUMBER;
   V_QTDEANTEPOS   NUMBER;
   V_VRESTANTPOS   NUMBER;
   V_VRBRUANTPOS   NUMBER;
   V_COUNTPOS      NUMBER;

   V_QTESTOQDIA    NUMBER;
   V_VRESTOQDIA    NUMBER;
   V_VRESTOQBRUT   NUMBER;
   V_IDRETORNO     VARCHAR2(01);

   V_NRLANCESTQ    VARCHAR2(14);
   V_DTAUXILIAR    DATE;

   V_TIPCUSTEST   NUMBER;
   V_CUSTESTOQ    NUMBER;
   V_DATAPROC     DATE;

   w_S            CHAR(1) := 'S';

   CURSOR C_MOVIMENTACAO IS SELECT I.IDTIPOMOVI, I.DTLANCMOVI, NVL(I.VRLANCTOEST,0) VRLANCTOEST,
                                   NVL(I.VRLANCTOBRUT, 0) VRLANCTOBRUT, I.QTLANCTOEST, I.IDALTCMEDMV,
                                   I.CDFILIAL, I.NRLANCESTQ, L.CDTIPOOPER
                            FROM ITLANCTOEST I, LANCTOESTOQ L
                            WHERE (I.CDFILIMOVI   = P_CDFILIMOVI)   AND
                                  (I.CDALMOXARIFE = P_CDALMOXARIFE) AND
                                  (I.CDLOCALESTOQ = P_CDLOCALESTOQ) AND
                                  (I.NRLOTEESTQ   = P_NRLOTEESTQ)   AND
                                  (I.NRSUBLOTE    = P_NRSUBLOTE)    AND
                                  (I.CDPRODMOVI   = P_CDPRODUTO)    AND
                                  (I.DTLANCMOVI   = P_DTPOSIESTQ)   AND
                                  (I.IDEVOLESTOQ  = w_S or IDEVOLESTOQ IS NULL) AND
                                  (I.CDFILIAL     = L.CDFILIAL)     AND
                                  (I.NRLANCESTQ   = L.NRLANCESTQ)
                           ORDER BY NVL(I.IDORDEMCLC, I.IDTIPOMOVI), I.NRLANCESTQ, I.NRSEQUITEM;

BEGIN

   BEGIN
      SELECT NVL(QTESTOQDIA, 0),
             NVL(VRESTOQDIA, 0),
             NVL(VRESTOQBRUT,0),
             NVL(QTESTOQANT, 0),
             NVL(VRESTOQANT, 0),
             NVL(VRBRUTOANT, 0),
             DTPOSIESTQ
      INTO   V_QTDEESTOPOS,
             V_VALRESTOPOS,
             V_VALRBRUTPOS,
             V_QTDEANTEPOS,
             V_VRESTANTPOS,
             V_VRBRUANTPOS,
             V_DTAUXILIAR
      FROM POSESTDIA
      WHERE (CDFILIAL     = P_CDFILIMOVI)
        AND (CDALMOXARIFE = P_CDALMOXARIFE)
        AND (CDLOCALESTOQ = P_CDLOCALESTOQ)
        AND (NRLOTEESTQ   = P_NRLOTEESTQ)
        AND (NRSUBLOTE    = P_NRSUBLOTE)
        AND (CDPRODUTO    = P_CDPRODUTO)
        AND (DTPOSIESTQ   = P_DTPOSIESTQ);
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       V_QTDEESTOPOS:= 0;
       V_VALRESTOPOS:= 0;
       V_VALRBRUTPOS:= 0;
       V_QTDEANTEPOS:= 0;
       V_VRESTANTPOS:= 0;
       V_VRBRUANTPOS:= 0;
       V_DTAUXILIAR:= NULL;
   END;
 
   IF (SQL%ROWCOUNT = 0) THEN

      BEGIN
         SELECT NVL(QTESTOQDIA, 0), 
                NVL(VRESTOQDIA, 0), 
                NVL(VRESTOQBRUT,0), 
                NVL(QTESTOQANT, 0), 
                NVL(VRESTOQANT, 0), 
                NVL(VRBRUTOANT, 0), 
                DTPOSIESTQ
         INTO   V_QTDEESTOPOS,
                V_VALRESTOPOS,
                V_VALRBRUTPOS,
                V_QTDEANTEPOS,
                V_VRESTANTPOS,
                V_VRBRUANTPOS,
                V_DTAUXILIAR
         FROM POSESTDIA
         WHERE (CDFILIAL     = P_CDFILIMOVI)
           AND (CDALMOXARIFE = P_CDALMOXARIFE)
           AND (CDLOCALESTOQ = P_CDLOCALESTOQ)
           AND (NRLOTEESTQ   = P_NRLOTEESTQ)
           AND (NRSUBLOTE    = P_NRSUBLOTE)
           AND (CDPRODUTO    = P_CDPRODUTO)
           AND (DTPOSIESTQ   = DTPOSICAO_POSESTDIA(P_CDFILIMOVI, P_CDPRODUTO, P_CDALMOXARIFE, P_CDLOCALESTOQ, P_NRLOTEESTQ, P_NRSUBLOTE, P_DTPOSIESTQ));
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_QTDEESTOPOS:= 0;
          V_VALRESTOPOS:= 0;
          V_VALRBRUTPOS:= 0;
          V_QTDEANTEPOS:= 0;
          V_VRESTANTPOS:= 0;
          V_VRBRUANTPOS:= 0;
          V_DTAUXILIAR:= NULL;
      END;
   END IF;

   V_QTDEESTO   := V_QTDEESTOPOS;
   V_VALRESTO   := V_VALRESTOPOS;
   V_VALRBRUT   := V_VALRBRUTPOS;
   V_QTDEANTE   := V_QTDEANTEPOS;
   V_VRESTANT   := V_VRESTANTPOS;
   V_VRBRUANT   := V_VRBRUANTPOS;

   P_VRESTANT   := V_VALRESTOPOS;
   P_QTESTOQANT := V_QTDEESTOPOS;

   IF (V_QTDEESTO <> 0) THEN
      V_QTDEANTE := V_QTDEANTEPOS;
      V_VRESTANT := V_VRESTANTPOS;
      V_VRBRUANT := V_VRBRUANTPOS;
   END IF;

   V_QTESTOQDIA  := 0;
   V_VRESTOQDIA  := 0;
   V_VRESTOQBRUT := 0;
   V_IDRETORNO   := 'N';
   V_NRLANCESTQ  := 'X';


   FOR C_MOVIESTQ IN C_MOVIMENTACAO LOOP
      Begin
        SELECT NVL(TO_NUMBER(CDTIPCUSTEST),3), NVL(DTPROCESSA, SYSDATE)
        INTO V_TIPCUSTEST, V_DATAPROC
        FROM PARAMFILIAL
        WHERE CDFILIAL = P_CDFILIMOVI;
      Exception
        When No_Data_Found Then
          V_TIPCUSTEST:= Null;
          V_DATAPROC  := Null;
      End;

      IF P_MOVI <> w_S THEN
         V_TIPCUSTEST := 3;
      END IF;

      IF V_TIPCUSTEST <> 3 THEN
         V_CUSTESTOQ := CUSTO_PRODUTO(P_CDFILIMOVI, P_CDPRODUTO, V_TIPCUSTEST, P_DTPOSIESTQ, V_DATAPROC);

      END IF;

      IF (V_CUSTESTOQ IS NULL) THEN
         V_CUSTESTOQ := 0;
      END IF;

      IF ((P_CDFILIAL||P_NRLANCESTQ) = (C_MOVIESTQ.CDFILIAL||C_MOVIESTQ.NRLANCESTQ)) AND (V_IDRETORNO = 'N') THEN
         IF V_TIPCUSTEST <> 3 THEN
            IF V_QTDEESTO <> 0 THEN
               V_QTESTOQDIA  := V_QTDEESTO;
            ELSE
               V_QTESTOQDIA  := 0;
               IF ROUND(ABS(V_QTDEANTE),8) <> 0 THEN
                  V_VRESTOQDIA  := V_VRESTANT;
                  V_VRESTOQBRUT := V_VRBRUANT;
                  P_QTESTOQANT  := V_QTDEANTE;
                  P_VRESTANT    := V_VRESTANT;
               END IF;
            END IF;
            V_VRESTOQDIA  :=  V_CUSTESTOQ ;
            V_VRESTOQBRUT :=  V_CUSTESTOQ ;
         ELSE
            IF V_QTDEESTO <> 0 THEN
               V_QTESTOQDIA  := V_QTDEESTO;
               V_VRESTOQDIA  := V_VALRESTO;
               V_VRESTOQBRUT := V_VALRBRUT;
            ELSE
               V_QTESTOQDIA  := 0;

               IF ROUND(ABS(V_QTDEANTE),8) > 0 THEN
                  V_VRESTOQDIA  := V_VRESTANT;
                  V_VRESTOQBRUT := V_VRBRUANT;
                  P_QTESTOQANT  := V_QTDEANTE;
                  P_VRESTANT    := V_VRESTANT;
               END IF;
            END IF;
         END IF;

         V_IDRETORNO := 'S';
      END IF;

      IF (V_QTDEESTO <> 0) THEN
         V_QTDEANTE := V_QTDEESTO;
         V_VRESTANT := V_VALRESTO;
         V_VRBRUANT := V_VALRBRUT;
      END IF;

      /* TRATAMENTO PARA CADA REGISTRO DE LANAMENTO DE ESTOQUE */
      IF (C_MOVIESTQ.IDTIPOMOVI = '0') THEN    /* IMPLANTAO */

         IF V_NRLANCESTQ <> C_MOVIESTQ.CDFILIAL||C_MOVIESTQ.NRLANCESTQ THEN
            V_VALRBRUT    := C_MOVIESTQ.VRLANCTOBRUT;
            V_VALRESTO    := C_MOVIESTQ.VRLANCTOEST;
            V_QTDEESTO    := C_MOVIESTQ.QTLANCTOEST;
         ELSE
            V_VALRBRUT    := V_VALRBRUT   + C_MOVIESTQ.VRLANCTOBRUT;
            V_VALRESTO    := V_VALRESTO   + C_MOVIESTQ.VRLANCTOEST;
            V_QTDEESTO    := V_QTDEESTO   + C_MOVIESTQ.QTLANCTOEST;
         END IF;

      ELSIF (C_MOVIESTQ.IDTIPOMOVI = '1') THEN    /* AJUSTES     */
         IF NVL(C_MOVIESTQ.IDALTCMEDMV,'N') <> 'S' THEN

            IF V_TIPCUSTEST <> 3 THEN
               V_VALRBRUT := (V_CUSTESTOQ * C_MOVIESTQ.QTLANCTOEST);
               V_VALRESTO := (V_CUSTESTOQ * C_MOVIESTQ.QTLANCTOEST);
            ELSE
               IF V_QTDEESTO = 0 THEN
                  IF V_QTDEANTE <> 0 THEN
                     V_VALRBRUT := (V_VRBRUANT/V_QTDEANTE)*C_MOVIESTQ.QTLANCTOEST;
                     V_VALRESTO := (V_VRESTANT/V_QTDEANTE)*C_MOVIESTQ.QTLANCTOEST;

                     V_VRBRUANT := 0;
                     V_VRESTANT := 0;
                     V_QTDEANTE := 0;
                  ELSE
                     V_VALRBRUT   := 0;
                     V_VALRESTO   := 0;
                     V_VRBRUANT   := 0;
                     V_VRESTANT   := 0;
                     V_QTDEANTE   := 0;
                  END IF;
               ELSE
                  IF V_QTDEESTO <> 0 THEN
                     V_VALRBRUT := (V_VALRBRUT/V_QTDEESTO)*C_MOVIESTQ.QTLANCTOEST;
                     V_VALRESTO := (V_VALRESTO/V_QTDEESTO)*C_MOVIESTQ.QTLANCTOEST;
                  END IF;
               END IF;

            END IF;
         END IF;
         V_QTDEESTO := C_MOVIESTQ.QTLANCTOEST;
      ELSIF (C_MOVIESTQ.IDTIPOMOVI = '2') THEN    /* ENTRADA */
         V_QTDEESTO := V_QTDEESTO + C_MOVIESTQ.QTLANCTOEST;

         IF (C_MOVIESTQ.QTLANCTOEST = 0) THEN
            IF C_MOVIESTQ.CDTIPOOPER = '03' THEN 
               V_VALRBRUT := V_VALRBRUT + C_MOVIESTQ.VRLANCTOBRUT;
               V_VALRESTO := V_VALRESTO + C_MOVIESTQ.VRLANCTOEST;
            END IF;
         ELSE
            V_VALRBRUT := V_VALRBRUT + (C_MOVIESTQ.QTLANCTOEST*C_MOVIESTQ.VRLANCTOBRUT);
            V_VALRESTO := V_VALRESTO + (C_MOVIESTQ.QTLANCTOEST*C_MOVIESTQ.VRLANCTOEST);
         END IF;

      ELSIF (C_MOVIESTQ.IDTIPOMOVI = '3') THEN    /* RETIRADA    */

         IF V_QTDEESTO > 0 THEN
            IF V_TIPCUSTEST <> 3 THEN
               V_VALRESTO := V_VALRBRUT - ((V_VRESTOQDIA/V_QTDEESTO) * C_MOVIESTQ.QTLANCTOEST);
               V_VALRBRUT := V_VALRESTO - ((V_VRESTOQDIA/V_QTDEESTO) * C_MOVIESTQ.QTLANCTOEST);
            ELSE
               V_VALRBRUT := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)*C_MOVIESTQ.QTLANCTOEST);
               V_VALRESTO := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)*C_MOVIESTQ.QTLANCTOEST);
            END IF;
         END IF;

         V_QTDEESTO := V_QTDEESTO - C_MOVIESTQ.QTLANCTOEST;

         IF (V_QTDEESTO < 0) THEN
            IF (V_QTDEANTE <> 0) THEN
               IF V_TIPCUSTEST <> 3 THEN
                  V_VALRESTO := V_VRESTOQDIA * V_QTDEESTO;
                  V_VALRBRUT := V_VRESTOQDIA * V_QTDEESTO;
               ELSE
                  V_VALRESTO := ((V_VRESTANT/V_QTDEANTE)*V_QTDEESTO);
                  V_VALRBRUT := ((V_VRBRUANT/V_QTDEANTE)*V_QTDEESTO);
               END IF;
            ELSE
               V_VALRESTO := 0;
               V_VALRBRUT := 0;
            END IF;
         END IF;

         IF ROUND(ABS(V_QTDEESTO),8) = 0 THEN
            V_QTDEESTO := 0;
         END IF;

         IF V_QTDEESTO  = 0 THEN
            V_VALRBRUT   := 0;
            V_VALRESTO   := 0;
         END IF;

      ELSIF (C_MOVIESTQ.IDTIPOMOVI = '4') THEN    /* SADA       */
         IF ABS(V_QTDEESTO) > 0 THEN
            IF (C_MOVIESTQ.QTLANCTOEST <> 0 OR C_MOVIESTQ.CDTIPOOPER = '03') THEN
               V_VALRBRUT := V_VALRBRUT - ((V_VALRBRUT/V_QTDEESTO)*C_MOVIESTQ.QTLANCTOEST);
               V_VALRESTO := V_VALRESTO - ((V_VALRESTO/V_QTDEESTO)*C_MOVIESTQ.QTLANCTOEST);
            END IF;
         END IF;

         V_QTDEESTO := V_QTDEESTO - C_MOVIESTQ.QTLANCTOEST;

         IF (V_QTDEESTO < 0) THEN
            IF (V_QTDEANTE <> 0) THEN
               IF V_TIPCUSTEST <> 3 THEN
                  V_VALRESTO := V_VRESTOQDIA * V_QTDEESTO;
                  V_VALRBRUT := V_VRESTOQDIA * V_QTDEESTO;
              ELSE
                  V_VALRESTO := ((V_VRESTANT/V_QTDEANTE)*V_QTDEESTO);
                  V_VALRBRUT := ((V_VRBRUANT/V_QTDEANTE)*V_QTDEESTO);
               END IF;
            ELSE
               V_VALRESTO := 0;
               V_VALRBRUT := 0;
            END IF;
         END IF;

         IF ROUND(ABS(V_QTDEESTO),8) = 0 THEN
            V_QTDEESTO := 0;
         END IF;

         IF V_QTDEESTO = 0 THEN
            V_VALRBRUT := 0;
            V_VALRESTO := 0;
         END IF;

      ELSIF (C_MOVIESTQ.IDTIPOMOVI = '5') THEN    /* DEV. FORN.  */
         IF NOT (C_MOVIESTQ.NRLANCESTQ = P_NRLANCESTQ) THEN  /* Incluido em virtude das sol. 87061 e 87042*/
            IF C_MOVIESTQ.QTLANCTOEST = 0 THEN
               V_VALRBRUT := V_VALRBRUT - C_MOVIESTQ.VRLANCTOBRUT;
               V_VALRESTO := V_VALRESTO - C_MOVIESTQ.VRLANCTOEST;
            ELSE
               V_VALRBRUT := V_VALRBRUT - (C_MOVIESTQ.QTLANCTOEST*C_MOVIESTQ.VRLANCTOBRUT);
               V_VALRESTO := V_VALRESTO - (C_MOVIESTQ.QTLANCTOEST*C_MOVIESTQ.VRLANCTOEST);
            END IF;

            V_QTDEESTO := V_QTDEESTO - C_MOVIESTQ.QTLANCTOEST;

            IF ROUND(V_QTDEESTO,3) = 0 THEN
               V_QTDEESTO := 0;
            END IF;

            IF V_QTDEESTO  = 0 THEN
               V_VALRBRUT   := 0;
               V_VALRESTO   := 0;
            END IF;
         ELSE /* Incluido em virtude das sol. 87061 e 87042*/
            IF V_VALRESTO - (C_MOVIESTQ.QTLANCTOEST*C_MOVIESTQ.VRLANCTOEST) >= 0 THEN
               V_VALRESTO := C_MOVIESTQ.VRLANCTOEST;
               V_VALRBRUT := C_MOVIESTQ.VRLANCTOBRUT;
            ELSE
               IF V_QTDEESTO <> 0 THEN
                  V_VALRESTO := V_VALRESTO/V_QTDEESTO;
                  V_VALRBRUT := V_VALRBRUT/V_QTDEESTO;
               ELSE
                  V_VALRESTO := CUSTO_PRODUTO(P_CDFILIMOVI, P_CDPRODUTO, V_TIPCUSTEST, P_DTPOSIESTQ, V_DATAPROC);
                  V_VALRBRUT := CUSTO_PRODUTO(P_CDFILIMOVI, P_CDPRODUTO, V_TIPCUSTEST, P_DTPOSIESTQ, V_DATAPROC);
               END IF;
            END IF;
            V_VRESTOQDIA  := V_VALRESTO;
            V_VRESTOQBRUT := V_VALRBRUT;
            EXIT;
         END IF;
      END IF;

      /* GUARDA OS VALORES DE ESTOQUE ANTERIORES  PRXIMA MOVIMENTAO */
      V_QTDEESTOPOS   := V_QTDEESTO;
      V_VALRESTOPOS   := V_VALRESTO;
      V_VALRBRUTPOS   := V_VALRBRUT;
      V_QTDEANTEPOS   := V_QTDEANTE;
      V_VRESTANTPOS   := V_VRESTANT;
      V_VRBRUANTPOS   := V_VRBRUANT;

      V_NRLANCESTQ := C_MOVIESTQ.CDFILIAL||C_MOVIESTQ.NRLANCESTQ;

   END LOOP;

   P_QTESTOQDIA  := V_QTESTOQDIA;
   P_VRESTOQDIA  := V_VRESTOQDIA;
   P_VRESTOQBRUT := V_VRESTOQBRUT;

END;
/


-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_SALDO_ANTERIOR','6.49.046'); END;
/

